#Code by Gilles TARNUS
#Email : gta974@gmail.com
#23 septembre 2015

# First we pull in the standard API hooks.
require 'sketchup.rb'

# Show the Ruby Console at startup so we can
# see any programming errors we may make.
#SKETCHUP_CONSOLE.show

# Add a menu item to launch our plugin.
UI.menu("Plugins").add_item("escalier by Gilles") {
  # Call function
  	@msg = "Esaclier :  Entrer les valeurs"
	Sketchup::set_status_text(@msg)
	dessin_gta

}



def dessin_gta
	
	#Unité et valeurs d'entree
	if Sketchup.active_model.options["UnitsOptions"]["LengthUnit"]>1
	inch=2.54
	prompts = ["L1 low", "L2 high", "width", "high"]
	defaults = ["300", "300","100", "300"]
	input = UI.inputbox(prompts, defaults, "dimensions cm")
	else 
	inch=1
	prompts = ["L1 low", "L2 high", "width", "high"]
	defaults = ["120", "120","40", "120"]
	input = UI.inputbox(prompts, defaults, "dimensions inch")
	end
	
	#constantes
    $giron=28.0 / 2.54 #le giron
    $rj=20.0 / 2.54 #le rayon de jour
	$alpha = Math::PI / 6 #l angle de rotation

	#contantes du modele
	mod = Sketchup.active_model # Open model
	ent = mod.entities # All entities in model
	sel = mod.selection # Current selection
	$group = Sketchup.active_model.entities.add_group
	
	#conversion des valeurs d'entree
	$lg1 = (input[0].to_f / inch).abs #longueur droite basse
	$lg2=(input[1].to_f / inch).abs #longueur droite haute
	$ht=(input[3].to_f / inch).abs #hauteur à franchir	
	$l=(input[2].to_f / inch).abs #la largeur
	
	
	
	#ligne de foulee au milieu si largeur < 1m sinon a 70 cm
	if input[2].to_f< 100 / inch
		$lf=input[2].to_f / inch / 2 #la largeur
	else $lf=70 / inch
	end
	
	#Calcul du nombre de marche pour avoir la hauteur de marche $h
	if $lg1>$l-$rj
	$n1=(($lg1-$l-$rj) / $giron).floor #nombre de marche droite basse
	else $n1=0
    end
	if $lg2>$l+$rj
	$n2=(($lg2-$l-$rj) / $giron).floor #nombre de marche droite haute
	else $n2=0
    end
	$h=$ht / ($n1+$n2+3) #hauteur de marche
	
	#Ajout de marche si necessaire sur la partie haute
    $ajout=0
	if $h>18 / 2.54
		$ajout=1
	elsif $h<16 / 2.54
		$ajout=-1
	end
	
	if $ajout!=0 && $lg1 > $l+$rj && $lg2 > $l+$rj
		ajust($n2,$n1)
	elsif $lg1 <= $l+$rj && $lg2 > $l+$rj
		ajust1
	else#if $lg1 > $l+$rj && $lg2 <= $l+$rj
		ajust2
	end
    
    # $h=$ht / ($n1+$n2+3) #hauteur de marche
	
	#initialisation : depart au centre de la scene
	$pt0 = Geom::Point3d.new(0,-$giron,0)
	$pts=[]
	
	partieBasse()
		
	partieTournante()
	 
	partieHaute()

end 

def ajust(n,m)
	if $ajout>0
	result = UI.messagebox("STEP too high, edit high?\nYes:  to auto-ajust high & length\nNo: continu to draw", MB_YESNO)
		if result == IDYES
		while (($h>18 / 2.54) && ($ajout>0))
		n+=$ajout
		$h=$ht / (n+m+3)
		$n2=n
		end
		end
	elsif $ajout<0
	result = UI.messagebox("STEP too low, edit high?\nYes:  to auto-ajust high & length\nNo: continu to draw", MB_YESNO)
		if result == IDYES
			while (($h<16 / 2.54) && ($ajout<0))
			n+=$ajout
			$h=$ht / (n+m+3)
			$n2=n
			end
		end
	end
end

def ajust1
	$n1=0
    while ($h>18 / 2.54) #&& ($ajout>0))
	$n2+=1
	$h=$ht / ($n2+3)
    print('AJUST11')
	end
	
	while ($h<16 / 2.54) #&& ($ajout<0))
	$n2-=1
	$h=$ht / ($n2+3)
    print('AJUST12')
	end
    
    while ($h>18 / 2.54) #&& ($ajout>0))
	$n2+=1
	$h=$ht / ($n2+3)
    print('AJUST11')
	end
end

def ajust2
	$n2=0
    while ($h>18 / 2.54) #&& ($ajout>0))
	$n1+=1
	$h=$ht / ($n1+3)
    print('AJUST21')
	end
    $n1-=1
        
	while ($h<16 / 2.54) #&& ($ajout<0))
	$n1-=1
	$h=$ht / ($n1+3)
    print('AJUST22')
	end
end

def partieBasse()	#Premiere partie droite, bas
	for stair1 in 1..$n1+1
		$pts=[$pt0,$pt0+[$l,0,0],$pt0+[$l,$giron,0],$pt0+[0,$giron,0]]
		$pts=$pts+[$pts[3]+[0,0,$h],$pts[2]+[0,0,$h]]
	
	    if stair1!=1
			$stairGroup = $group.entities.add_face $pts[0], $pts[1],$pts[2],$pts[3]
	    end
		$stairGroup = $group.entities.add_face $pts[2],$pts[5],$pts[4],$pts[3]
		$pt0=$pts[3]
		$pt0=$pt0+[0,0,$h]
	end
end

def partieTournante()	#quart tournant 3 marches sur 90°
	$a=Math.tan($alpha) * $rj
	$b=$rj-$a
	$aprime=($rj+$l)*$a / $rj
	$bprime=$l+$rj-$aprime
	
	  #Marche tournante 1/3
	  $pts=[$pt0,$pt0+[$l,0,0]]
	  $pts=$pts+[$pts[1]+[0,$a,0],$pts[0]+[0,$aprime,0]]
	  $stairGroup = $group.entities.add_face $pts[0], $pts[1],$pts[2],$pts[3]
	  $stairGroup = $group.entities.add_face $pts[2], $pts[2]+[0,0,$h],$pts[3]+[0,0,$h],$pts[3]
	  $pt0=$pts[3]+[0,0,$h]
	  
	  #Marche tournante 2/3
	  $pts=[$pt0,$pt0+[$l,-$aprime+$a,0]]
	  $pts=$pts+[$pts[1]+[0,$b,0]]
	  $pts=$pts+[$pts[2]+[$b,0,0]]
	  $pts=$pts+[$pts[3]+[-$l-$rj+$bprime+$a,$l,0]]
	  $pts=$pts+[$pts[4]+[-$bprime,0,0]]
	  $stairGroup = $group.entities.add_face $pts[0], $pts[1],$pts[2],$pts[3],$pts[4],$pts[5]
	  $stairGroup = $group.entities.add_face $pts[3], $pts[3]+[0,0,$h],$pts[4]+[0,0,$h],$pts[4]
	  $pt0=$pts[4]+[0,0,$h]
	
	  #Marche tournante 3/3
	  $pts=[$pt0,$pt0+[$aprime-$a,-$l,0]]
	  $pts=$pts+[$pts[1]+[$a,0,0]]
      $pts=$pts+[$pts[2]+[0,$l,0]]
 	  $stairGroup = $group.entities.add_face $pts[0], $pts[1],$pts[2],$pts[3]
	  $stairGroup = $group.entities.add_face $pts[2], $pts[2]+[0,0,$h],$pts[3]+[0,0,$h],$pts[3]
	  $pt0=$pts[3]+[0,0,$h]
end

def partieHaute()	#deuxieme partie droite, haut
	#print $n2.to_s
	for stair2 in 1..$n2
		$pts=[$pt0,$pt0+[0,-$l,0],$pt0+[$giron,-$l,0],$pt0+[$giron,0,0]]
		$pts=$pts+[$pts[3]+[0,0,$h],$pts[2]+[0,0,$h]]
	    if stair2!=$n2
			$stairGroup = $group.entities.add_face $pts[0], $pts[1],$pts[2],$pts[3]
			$stairGroup = $group.entities.add_face $pts[2],$pts[5],$pts[4],$pts[3]
		end
		$pt0=$pts[3]
		$pt0=$pt0+[0,0,$h]
	end
end
	
#dessin_gta
	
# of dessin_gta